mi-malloc: Extended Functions

| mi-malloc 1.8/2.1 |

Loading...
Searching...
No Matches
Macros | Typedefs | Functions
Extended Functions

Internal functionality. More...

## Macros
#define | MI_SMALL_SIZE_MAX
| Maximum size allowed for small allocations in mi_malloc_small, mi_zalloc_small, mi_heap_malloc_small, mi_heap_zalloc_small, mi_theap_malloc_small, and mi_theap_zalloc_small (usually `128*sizeof(void*)` (= 1KB on 64-bit systems))

## Typedefs
typedef void | mi_deferred_free_fun(bool force, unsigned long long heartbeat, void *arg)
| Type of deferred free functions.
typedef void | mi_output_fun(const char *msg, void *arg)
| Type of output functions.
typedef void | mi_error_fun(int err, void *arg)
| Type of error callback functions.

## Functions
int | mi_version (void)
| Return the mimalloc version.
void | mi_collect (bool force)
| Eagerly free memory.
void | mi_thread_set_in_threadpool (void)
| v3: Communicate that a thread is in a threadpool.
bool | mi_is_redirected ()
| Is the C runtime malloc API redirected?
void | mi_thread_init (void)
| Initialize mimalloc on a thread.
void | mi_thread_done (void)
| Uninitialize mimalloc on a thread.
void | mi_register_deferred_free (mi_deferred_free_fun *deferred_free, void *arg)
| Register a deferred free function.
void | mi_register_output (mi_output_fun *out, void *arg)
| Register an output function.
void | mi_register_error (mi_error_fun *errfun, void *arg)
| Register an error callback function.
void * | mi_malloc_small (size_t size)
| Allocate a small object.
void * | mi_zalloc_small (size_t size)
| Allocate a zero initialized small object.
void | mi_free_small (void *p)
| v3: Can be used to free an object that was allocated with mi_malloc_small et al.

## Detailed Description

Internal functionality.

## Macro Definition Documentation

## ◆ MI_SMALL_SIZE_MAX

#define MI_SMALL_SIZE_MAX

Maximum size allowed for small allocations in mi_malloc_small, mi_zalloc_small, mi_heap_malloc_small, mi_heap_zalloc_small, mi_theap_malloc_small, and mi_theap_zalloc_small (usually `128*sizeof(void*)` (= 1KB on 64-bit systems))

## Typedef Documentation

## ◆ mi_deferred_free_fun

typedef void mi_deferred_free_fun(bool force, unsigned long long heartbeat, void *arg)

Type of deferred free functions.

Parameters

  force | If true all outstanding items should be freed.
  heartbeat | A monotonically increasing count.
  arg | Argument that was passed at registration to hold extra state.

See also
  mi_register_deferred_free

## ◆ mi_error_fun

typedef void mi_error_fun(int err, void *arg)

Type of error callback functions.

Parameters

  err | Error code (see mi_register_error() for a complete list).
  arg | Argument that was passed at registration to hold extra state.

See also
  mi_register_error()

## ◆ mi_output_fun

typedef void mi_output_fun(const char *msg, void *arg)

Type of output functions.

Parameters

  msg | Message to output.
  arg | Argument that was passed at registration to hold extra state.

See also
  mi_register_output()

## Function Documentation

## ◆ mi_collect()

void mi_collect | ( | bool | force | ) |

Eagerly free memory.

Parameters

  force | If true, aggressively return memory to the OS (can be expensive!)

Regular code should not have to call this function. It can be beneficial in very narrow circumstances; in particular, when a long running thread allocates a lot of blocks that are freed by other threads it may improve resource usage by calling this every once in a while.

## ◆ mi_free_small()

void mi_free_small | ( | void * | p | ) |

v3: Can be used to free an object that was allocated with mi_malloc_small et al.

Parameters

  p | Pointer that was returned from mi_malloc_small et al.

This function is meant for use in run-time systems for best performance and does not check if the pointer was indeed allocated with mi_malloc_small (et al) – use with care! This function has a small perf benefit but only if mimalloc was built with `MI_FAST_FREE_SMALL=1`

See also
  mi_malloc_small()
  mi_zalloc_small()
  mi_heap_malloc_small()
  mi_heap_zalloc_small()
  mi_theap_malloc_small()
  mi_theap_zalloc_small()

## ◆ mi_is_redirected()

bool mi_is_redirected | ( |  | ) |

Is the C runtime malloc API redirected?

Returns
  true if all malloc API calls are redirected to mimalloc.

Currently only used on Windows.

## ◆ mi_malloc_small()

void * mi_malloc_small | ( | size_t | size | ) |

Allocate a small object.

Parameters

  size | The size in bytes, can be at most MI_SMALL_SIZE_MAX.

Returns
  a pointer to newly allocated memory of at least size bytes, or NULL if out of memory. This function is meant for use in run-time systems for best performance and does not check if size was indeed small – use with care!

## ◆ mi_register_deferred_free()

void mi_register_deferred_free | ( | mi_deferred_free_fun * | deferred_free,
|  | void * | arg )

Register a deferred free function.

Parameters

  deferred_free | Address of a deferred free-ing function or NULL to unregister.
  arg | Argument that will be passed on to the deferred free function.

Some runtime systems use deferred free-ing, for example when using reference counting to limit the worst case free time. Such systems can register (re-entrant) deferred free function to free more memory on demand. When the force parameter is true all possible memory should be freed. The per-thread heartbeat parameter is monotonically increasing and guaranteed to be deterministic if the program allocates deterministically. The deferred_free function is guaranteed to be called deterministically after some number of allocations (regardless of freeing or available free memory). At most one deferred_free function can be active.

## ◆ mi_register_error()

void mi_register_error | ( | mi_error_fun * | errfun,
|  | void * | arg )

Register an error callback function.

Parameters

  errfun | The error function that is called on an error (use NULL for default)
  arg | Extra argument that will be passed on to the error function.

The errfun function is called on an error in mimalloc after emitting an error message (through the output function). It as always legal to just return from the errfun function in which case allocation functions generally return NULL or ignore the condition. The default function only calls abort() when compiled in secure mode with an EFAULT error. The possible error codes are:

- EAGAIN: Double free was detected (only in debug and secure mode).
- EFAULT: Corrupted free list or meta-data was detected (only in debug and secure mode).
- ENOMEM: Not enough memory available to satisfy the request.
- EOVERFLOW: Too large a request, for example in mi_calloc(), the count and size parameters are too large.
- EINVAL: Trying to free or re-allocate an invalid pointer.

## ◆ mi_register_output()

void mi_register_output | ( | mi_output_fun * | out,
|  | void * | arg )

Register an output function.

Parameters

  out | The output function, use `NULL` to output to stderr.
  arg | Argument that will be passed on to the output function.

The `out` function is called to output any information from mimalloc, like verbose or warning messages.

## ◆ mi_thread_done()

void mi_thread_done | ( | void |  | ) |

Uninitialize mimalloc on a thread.

Should not be used as on most systems (pthreads, windows) this is done automatically. Ensures that any memory that is not freed yet (but will be freed by other threads in the future) is properly handled.

## ◆ mi_thread_init()

void mi_thread_init | ( | void |  | ) |

Initialize mimalloc on a thread.

Should not be used as on most systems (pthreads, windows) this is done automatically.

## ◆ mi_thread_set_in_threadpool()

void mi_thread_set_in_threadpool | ( | void |  | ) |

v3: Communicate that a thread is in a threadpool.

This is done automatically for threads in the Windows threadpool, but if using a custom threadpool it is good to call this on worker threads. Internally, mimalloc uses different locality heuristics for worker threads to try to reduce non-local accesss.

## ◆ mi_version()

int mi_version | ( | void |  | ) |

Return the mimalloc version.

Returns
  The version. For v1,v2 the version is 100*major + 10*minor + patch (for example 227 for v2.2.7). For v3, it is 1000*major + 100*minor + path (for example, 3207 for v3.2.7).

## ◆ mi_zalloc_small()

void * mi_zalloc_small | ( | size_t | size | ) |

Allocate a zero initialized small object.

Parameters

  size | The size in bytes, can be at most MI_SMALL_SIZE_MAX.

Returns
  a pointer to newly allocated zero-initialized memory of at least size bytes, or NULL if out of memory. This function is meant for use in run-time systems for best performance and does not check if size was indeed small – use with care!